/* **********************************************************
 * Copyright (c) 2024 Google, Inc.  All rights reserved.
 * **********************************************************/

/*
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * * Neither the name of VMware, Inc. nor the names of its contributors may be
 *   used to endorse or promote products derived from this software without
 *   specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL VMWARE, INC. OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/* Keep this array (d_r_reg_virtual_names[]) and DR_REG_V enum in core/ir/opnd_api.h
 * synched.
 */
const char *const d_r_reg_virtual_names[] = {
    "rv_null", "rv_invalid", "rv0",   "rv1",        "rv2",   "rv3",   "rv4",   "rv5",
    "rv6",     "rv7",        "rv8",   "rv9",        "rv10",  "rv11",  "rv12",  "rv13",
    "rv14",    "rv15",       "rv16",  "rv17",       "rv18",  "rv19",  "rv20",  "rv21",
    "rv22",    "rv23",       "rv24",  "rv25",       "rv26",  "rv27",  "rv28",  "rv29",
    "rv30",    "rv31",       "rv32",  "rv33",       "rv34",  "rv35",  "rv36",  "rv37",
    "rv38",    "rv39",       "rv40",  "rv41",       "rv42",  "rv43",  "rv44",  "rv45",
    "rv46",    "rv47",       "rv48",  "rv49",       "rv50",  "rv51",  "rv52",  "rv53",
    "rv54",    "rv55",       "rv56",  "rv57",       "rv58",  "rv59",  "rv60",  "rv61",
    "rv62",    "rv63",       "rv64",  "rv65",       "rv66",  "rv67",  "rv68",  "rv69",
    "rv70",    "rv71",       "rv72",  "rv73",       "rv74",  "rv75",  "rv76",  "rv77",
    "rv78",    "rv79",       "rv80",  "rv81",       "rv82",  "rv83",  "rv84",  "rv85",
    "rv86",    "rv87",       "rv88",  "rv89",       "rv90",  "rv91",  "rv92",  "rv93",
    "rv94",    "rv95",       "rv96",  "rv97",       "rv98",  "rv99",  "rv100", "rv101",
    "rv102",   "rv103",      "rv104", "rv105",      "rv106", "rv107", "rv108", "rv109",
    "rv110",   "rv111",      "rv112", "rv113",      "rv114", "rv115", "rv116", "rv117",
    "rv118",   "rv119",      "rv120", "rv121",      "rv122", "rv123", "rv124", "rv125",
    "rv126",   "rv127",      "rv128", "rv129",      "rv130", "rv131", "rv132", "rv133",
    "rv134",   "rv135",      "rv136", "rv137",      "rv138", "rv139", "rv140", "rv141",
    "rv142",   "rv143",      "rv144", "rv145",      "rv146", "rv147", "rv148", "rv149",
    "rv150",   "rv151",      "rv152", "rv153",      "rv154", "rv155", "rv156", "rv157",
    "rv158",   "rv159",      "rv160", "rv161",      "rv162", "rv163", "rv164", "rv165",
    "rv166",   "rv167",      "rv168", "rv169",      "rv170", "rv171", "rv172", "rv173",
    "rv174",   "rv175",      "rv176", "rv177",      "rv178", "rv179", "rv180", "rv181",
    "rv182",   "rv183",      "rv184", "rv_invalid", "rv185", "rv186", "rv187", "rv188",
    "rv189",   "rv190",      "rv191", "rv192",      "rv193", "rv194", "rv195", "rv196",
    "rv197",   "rv198",      "rv199", "rv200",      "rv201", "rv202", "rv203", "rv204",
    "rv205",   "rv206",      "rv207", "rv208",      "rv209", "rv210", "rv211", "rv212",
    "rv213",   "rv214",      "rv215", "rv216",      "rv217", "rv218", "rv219", "rv220",
    "rv221",   "rv222",      "rv223", "rv224",      "rv225", "rv226", "rv227", "rv228",
    "rv229",   "rv230",      "rv231", "rv232",      "rv233", "rv234", "rv235", "rv236",
    "rv237",   "rv238",      "rv239", "rv240",      "rv241", "rv242", "rv243", "rv244",
    "rv245",   "rv246",      "rv247", "rv248",      "rv249", "rv250", "rv251", "rv252",
};
